﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GetCRC
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        ushort PRESET_VALUE = 0xffff;
        ushort POLYNOMIAL = 0x8408;
        private void GetCRC(byte[] pData, int ADataLen)
        {
            try
            {
                int i, j;
                ushort current_crc_value;
                current_crc_value = PRESET_VALUE;
                for (i = 0; i <= ADataLen - 1; i++)
                {
                    current_crc_value = (ushort)(current_crc_value ^ (pData[i]));
                    for (j = 0; j < 8; j++)
                    {
                        if ((current_crc_value & 0x0001) != 0)
                        {
                            current_crc_value = (ushort)((current_crc_value >> 1) ^ POLYNOMIAL);
                        }
                        else
                        {
                            current_crc_value = (ushort)(current_crc_value >> 1);
                        }
                    }
                }
                pData[i++] = (byte)(current_crc_value & 0x000000ff);
                pData[i] = (byte)((current_crc_value >> 8) & 0x000000ff);
            }
            catch(Exception ex)
            {
                return;
            }

        }
        byte[] SendBuff = new byte[300];
        private byte[] strToToHexByte(string hexString)
        {
            hexString = hexString.Replace(" ", "");
            if ((hexString.Length % 2) != 0)
                hexString += " ";
            byte[] returnBytes = new byte[hexString.Length / 2];
            for (int i = 0; i < returnBytes.Length; i++)
                returnBytes[i] = Convert.ToByte(hexString.Substring(i * 2, 2), 16);
            return returnBytes;
        }
        private void button1_Click(object sender, EventArgs e)
        { 
            SendBuff = strToToHexByte(this.txtCode.Text + "0000");
            GetCRC(SendBuff, SendBuff[0] - 1);
            byte[] ss = SendBuff;
            this.txtValue.Text = byteToHexStr(ss);
        }
        public static string byteToHexStr(byte[] bytes)
        {
            string returnStr = "";
            if (bytes != null)
            {
                for (int i = 0; i < bytes.Length; i++)
                {
                    returnStr += bytes[i].ToString("X2");
                }
            }
            return returnStr;
        }
    }
}
